import { CanvasConfig, GradientType, LinearGradient, Pattern, RadialGradient, Tuple3Number } from '@antv/g-lite';
export type GradientParams = (LinearGradient & RadialGradient) & {
    width: number;
    height: number;
    /**
     * Top-left corner
     */
    min: [number, number];
    type: GradientType;
};
export declare class ImagePool {
    private canvasConfig;
    private imageCache;
    private gradientCache;
    private patternCache;
    constructor(canvasConfig: Partial<CanvasConfig>);
    getImageSync(src: string, callback?: (img: HTMLImageElement) => void): HTMLImageElement;
    getOrCreateImage(src: string): Promise<HTMLImageElement>;
    getOrCreatePatternSync(pattern: Pattern, context: CanvasRenderingContext2D, $offscreenCanvas: HTMLCanvasElement, dpr: number, min: Tuple3Number, callback: () => void): CanvasPattern;
    getOrCreateGradient(params: GradientParams, context: CanvasRenderingContext2D): CanvasGradient;
    private generateGradientKey;
    private generatePatternKey;
}
